
#define MLX90614_ADDR 0x5A
// SCL    -  GPIO5 - D1
// SDA    -  GPIO4 - D2

// RAM
#define MLX90614_RAWIR1 0x04
#define MLX90614_RAWIR2 0x05
#define MLX90614_TA 0x06
#define MLX90614_TOBJ1 0x07
#define MLX90614_TOBJ2 0x08
// EEPROM
#define MLX90614_TOMAX 0x20
#define MLX90614_TOMIN 0x21
#define MLX90614_PWMCTRL 0x22
#define MLX90614_TARANGE 0x23
#define MLX90614_EMISS 0x24
#define MLX90614_CONFIG 0x25
#define MLX90614_AD  0x2E
#define MLX90614_ID1 0x3C
#define MLX90614_ID2 0x3D
#define MLX90614_ID3 0x3E
#define MLX90614_ID4 0x3F

bool isConnected()
{
  Wire.beginTransmission(MLX90614_ADDR);
  return ( Wire.endTransmission() == 0);
}

static void pwmtoi2c() 
{
  Wire.endTransmission(true);
  pinMode(SCL, INPUT); // SCL high
  pinMode(SDA, OUTPUT);
  digitalWrite(SDA, LOW); // SDA low
  delay(50); // delay at least 33ms
  pinMode(SDA, INPUT); // SDA high
  delay(250);
  pinMode(SCL, OUTPUT);
  digitalWrite(SCL, LOW); // SCL low
  delay(10); // Delay at least 1.44ms
  pinMode(SCL, INPUT); // SCL high
}

static void writeRegister(byte reg, uint8_t value) 
{
  Wire.beginTransmission(MLX90614_ADDR);
  Wire.write(reg);
  Wire.write(value);
  Wire.endTransmission();
}

uint16_t readRegister(byte reg) 
{
  uint16_t res1,res2,res;
  Wire.beginTransmission(MLX90614_ADDR);
  Wire.write(reg);
  if (Wire.endTransmission(false) == 0) 
  {
    Wire.requestFrom(MLX90614_ADDR,3);
    res1 = Wire.read();
    res2 = Wire.read();
    res = res1 + res2*256;
  }
  Wire.endTransmission();
  return res;
}


void MLX90614_ADDR_init()
{
  Wire.begin(4,5); // sda,scl
  delay(100);
  if (isConnected()) Serial.println("Sensor OK");
  else Serial.println("Sensor NOT OK");
}
